<dx-data-grid class="gridContainer box-shadow" #permitGrid [columnAutoWidth]='true' [allowColumnResizing]='true'
  [allowColumnReordering]='true' [showColumnLines]='ui.showColumnLines' [showRowLines]='ui.showRowLines'
  [hoverStateEnabled]="true" [dataSource]='dsPermit' (onToolbarPreparing)='toolbarPreparing($event)' [height]='ui.fullHeight'>
  <dxo-export [enabled]='true' [enabled]='true' fileName='permits'></dxo-export>
  <dxo-header-filter [visible]='true'></dxo-header-filter>
  <dxo-group-panel [visible]='true'></dxo-group-panel>
  <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
  <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='true'></dxo-scrolling>
  <dxo-search-panel [visible]='true'></dxo-search-panel>
  <dxo-state-storing [enabled]="true" type="localStorage" storageKey="qhsePermits"></dxo-state-storing>
  <dxo-filter-row [visible]='true'></dxo-filter-row>
  <dxo-column-chooser [enabled]="true" mode='dragAndDrop'></dxo-column-chooser>
  <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
  <dxo-master-detail [enabled]='true' template='details'></dxo-master-detail>

  <dxi-column caption='Număr aviz / autorizație / acord' dataField='no' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
  <dxi-column caption='Tip document' dataField='typeId' dataType='number' minWidth='280' [allowHeaderFiltering]='false'>
    <dxo-lookup [dataSource]='dsPermitsType' valueExpr='id' displayExpr='value'></dxo-lookup>
  </dxi-column>
  <dxi-column caption='Entitate' dataField='entityId' minWidth='170' dataType='string'>
    <dxo-lookup [dataSource]='pWithActiv' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column caption='Valabilitate' dataField='validity' minWidth='170' dataType='date' calculateSortValue='validity'
    [calculateDisplayValue]='ds.getDate'></dxi-column>
  <dxi-column caption='Revizuit la data' dataField='revision' minWidth='170' dataType='date' calculateSortValue='revision'
    [calculateDisplayValue]='ds.getDate'></dxi-column>
  <dxi-column caption='Validitate' dataField='isValid' minWidth='110' dataType='number' [allowHeaderFiltering]='false'>
    <dxo-lookup [dataSource]='dsBoolean' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column caption='Descriere' dataField='description' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
  <dxi-column type="buttons" fixedPosition='left' [width]='110' [fixed]='true' [allowResizing]='false'
    [showInColumnChooser]='false'>
    <dxi-button hint='Editează' icon="edit" [onClick]="onEditPermitsClick"></dxi-button>
    <dxi-button hint='Șterge' icon='trash' [onClick]="onDeletePermitsClick"></dxi-button>
  </dxi-column>

  <div *dxTemplate='let data of "details"'>
    <app-file-upload [gridData]='data'></app-file-upload>
  </div>

</dx-data-grid>

<dx-popup [(visible)]='edit.isPermitVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
  (onHidden)='ui.onPopupHidden($event)' height='auto' [title]='popupTitle'>
  <div *dxTemplate="let data of 'content'">
    <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
      <app-edit-permit [permitData]='edit.permitModel'></app-edit-permit>
    </dx-scroll-view>
  </div>
  <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSavePermit, validationGroup: edit.permitValidation }">
  </dxi-toolbar-item>
</dx-popup>